/*	
 *	cliptask.h
 *
 *	^XNRg[`܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001 Naoyuki Sawa
 *
 *	* Fri Nov 30 14:14:09 JST 2001 Naoyuki Sawa
 *	- 쐬JnB
 *	* Fri Nov 30 16:31:29 JST 2001 Naoyuki Sawa
 *	- 1st[XB
 */
#ifndef __CLIP_TASK_H__
#define __CLIP_TASK_H__

/*****************************************************************************
 *	TASK
 *****************************************************************************/

typedef struct _TASK TASK;

/* ^XNnh̃vg^CvłB
 */
typedef void (*TASKFREEPROC)(TASK* task);	/* Freenh */
typedef int  (*TASKWORKPROC)(TASK* task);	/* Worknh */
typedef void (*TASKDRAWPROC)(TASK* task);	/* Drawnh */

/* [U[`^XN̋ʃwb_łB
 */
struct _TASK {
	int suspend;		/* TXyhJE^
				 *  1ȏ: TXyh(W[)
				 *  0    : ʏ̏
				 * -1ȉ: TXyh(W[Ȃ)
				 */

	TASK* parent;		/* e^XN(NULL:gbvx) */
	TASK* siblings;		/* ̌Z^XN(NULL:I[) */
	TASK* children;		/* ŏ̎q^XN(NULL:Ȃ) */

	TASKFREEPROC free;	/* Freenh(NULL:Ȃ) */
	TASKWORKPROC work;	/* Worknh(NULL:Ȃ) */
	TASKDRAWPROC draw;	/* Drawnh(NULL:Ȃ) */
};

/* ^XN쐬܂B
 * [in]
 *	parent		e^XNւ̃|C^B
 *			NULLw肷ƁAgbvx^XNƂȂ܂B
 *	data_size	f[^̈̃oCgB
 * [out]
 *	߂l		쐬^XNւ̃|C^B
 *			mۂłȂ΁ANULLԂ܂B
 */
TASK* task_new(TASK* parent, int data_size);

/* ^XNJ܂B
 * [in]
 *	task		^XNւ̃|C^B
 */
void task_free(TASK* task);

/* SĂ̎q^XNJ܂B
 * [in]
 *	task		^XNւ̃|C^B
 */
void task_clear(TASK* task);

/* WorknhĂяo܂B
 * [in]
 *	task		^XNւ̃|C^B
 * [note]
 *	߂l		Worknh0ԂA
 *			^XNJāÅ֐0Ԃ܂B
 *			Worknh0ȊO̒lԂA
 *			^XNJÅ֐0ȊO̒lԂ܂B
 */
int task_work(TASK* task);

/* DrawnhĂяo܂B
 * [in]
 *	task		^XNւ̃|C^B
 */
void task_draw(TASK* task);

/* ^XNXgɊ܂܂^XN̐𐔂܂B
 * [in]
 *	task		^XNւ̃|C^B
 * [out]
 *	߂l		^XN̐
 * [note]
 *	* ^XN̐ɂ́AɎw肵taskg܂܂܂B
 *	  ]āAtaskNULLłȂA߂l1ȏɂȂ܂B
 *	  taskNULLw肵ꍇ̂݁A߂l0ɂȂ܂B
 */
int task_count(TASK* task);

#endif /*__CLIP_TASK_H__*/

